/* LIFE 3d vedi le scienze Aprile 1987 numero 224 Scientific American */
/* pag. 98 {ri} Creazioni al calcolatore */

#include <math.h>
#include <graphics.h>

typedef struct {
 int x,y;
} POINT;

float punti3[8][3]  = {{0,0,50},{0,0,0},{50,0,0},{50,0,50},
		       {0,50,50},{0,50,0},{50,50,0},{50,50,50}};
int	segm[12][2] = {{12},{2,3},{3,4},{4,1},{5,6},{6,7},{7,8},
			{8,5},{1,5},{2,6},{3,7},{4,8}},
	facce[3][4] = {{1,2,6,5},{1,4,3,2},{2,3,7,6}};

int  	cellule[2][10][10][10],
		stato,
		quale,adiac,fi,fs,ai,as;

float ca,cb,cc,sa,sb,sc,k1,k2,k3,k4,k5,k6,k7,k8,k9,k10,l,m;
int   gm,gd,buff,
		x1,y1,z1,x,y,z,a,b,c;
POINT punti2[51];


void calcconst(float a1,float a2,float n,float a,float b,float c,float k);

void draw(int x1,int y1,int x2,int y2,int color);
{
 setcolor(color);
 line(x1,y1,x2,y2);
}

void calcconst(float a1,float a2,float n,float a,float b,float c,float k)
{
 ca = cos(a); sa = sin(a);
 cb = cos(b); sb = sin(b);
 cc = cos(c); sc = sin(c);
 k1 = cb*cc; k2 = sa*sb*cc-ca*sc; k3 = ca*sb*cc+sa*sc; k4 = cb*sc;
 k5 = sa*sb*sc+ca*cc; k6 = ca*sb*sc-sa*cc; k7 = (sa * cb)/k; k8 = (ca*cb)/k;
 k9 = -sb/k; k10 =n/k;
 l = a1; m = a2;
}

void go3dim(float x,float y,float z, int *x2d, int *y2d)
{
 float xa,ya,wa;
 long b1,b2;

 xa = x*k1 + y*k2 + z*k3+l;
 ya = x*k4+y*k5+z*k6+m;
 wa = x*k9+y*k7+z*k8+k10+1;
 b1 = ceil(xa/wa);
 b2 = ceil(ya/wa);

 *x2d = (int)b1;
 *y2d = (int)b2;
}

void calc2d(int x,int y,int z)
{
 int i;

 for (i=0;i<8;i++)
 {
  go3dim(punti3[i][0]+x,punti3[i][1]+y,punti3[i][2]+z,
			&punti2[i].x, &punti2[i].y);
 }
}

void wires(int x,int y,int z,int par)
{
 int i,i1,i3;

 for (i=0;i<12;i++)
 {
  i1 = segm[i][0];
  i3 = segm[i][1];
  draw(punti2[i1].x, punti2[i1].y,punti2[i3].x,punti2[i3].y, par);
 }
}

void  drawcube(int x,int y,int z)
{
 POINT poly[4];
 int i,i1;

 calc2d(x,y,z);
 wires(x,y,z,1);
 for (i=0; i<3; i++)
 {
  for (i1=0; i<4; i++) poly[i1] = punti2[facce[i][i1]];
  setfillstyle(1,1);
  fillpoly(4,poly);
 }
}

void adiacenti(int i,int j,int k, int *tot)
{
 int l,m,n,who;

 tot = 0;
 who = !quale;
 for (l = i-1; l <= i+1; l++)
	for (m = j-1 ; m <= j+1; m++)
		for (n = k-1; n <= k+1; k++)
			if (cellule[who][l][m][n]) tot++;
 if (cellule[who][i][j][k]) tot--;
}

void chestato(int i, int j, int k, int quanti)
{
 int other;

 other = !quale;
 if (cellule[other][i][j][k])
	if ((quanti<ai) || (quanti>as)) cellule[quale][i][j][k] = 0;
	else cellule[quale][i][j][k] =1;
 else if ((quanti<fi) || (quanti>fs)) cellule[quale][i][j][k] = 0;
		else cellule[quale][i][j][k] = 1;
}

void eraseall(void)
{
 int i;

 for (z=9; z>=0; z--)
	for (y=9; y>=0; y--)
		for (x=9; x>=0; x--)
			for (i=0; i<2; i++)
				cellule[i][x][y][z] = 0;
}

void input(void)
{
 z ==8; x =8; y=8;
 do
  {
	a=600;b =0; c=-100;
	x1=x*65+a; y1 = y*65+b; z1 = z*65;
	calc2d(x1,y1,z1,1);
	wires(x1,y1,z1,1);
	car = getch();
	switch car
	{
	  case 'y': cellule[1][x][y][z] =1;
					drawcube(x1,y1,z1);
					break
	  case '6': if x<8 x++;
					break;
	  case '4': if x>1 x--;
					break;
	  case '8': if y>1 y--;
	  case '2': if y<8 y++;
	  case '5': z--;
	  case 27 : return;
	}
   wires(x1,y1,z1,0);
  }
  while ((car = 27) or (z=0))
}

void main(void)
{
 gd = DETECT;
 detectgraph(gd,gm);
 initgraph(gd,gm,"");
 ai = 4; as =5; fi =5; fs =5;
 calcconst(-150,50,-100,0,-0.45,0,1000);
 eraseall();
 input();
 quale = 0;
 do
 {
  initgraph(gd,gm,"");
  for (z=8; z>0; z--)
	for (y=8; y>0; y--)
	 for (x=8; x>0; x--)
	 {
	  adiacenti(x,y,z,adiac);
	  chestato(x,y,z,adiac);
	  if (cellule[quale][x][y][z]) drawcube(x*65+a,y+65+b,z*65+c);
	 }
  quale = !quale;
  car = getch();
 }
 while (car == 27)
 closegraph();
 restorecrtmode();
}
